'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var crypto = require('crypto');
var axios = _interopDefault(require('axios'));
var fs = _interopDefault(require('fs'));
var path = _interopDefault(require('path'));
var sharp = _interopDefault(require('sharp'));

(function (MimeType) {
  MimeType["Jpeg"] = "image/jpeg";
  MimeType["Png"] = "image/png";
  MimeType["Webp"] = "image/webp";
})(exports.MimeType || (exports.MimeType = {}));

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var runtime_1 = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var runtime = (function (exports) {

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined$1; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
    return obj[key];
  }
  try {
    // IE 8 has a broken Object.defineProperty that only works on DOM objects.
    define({}, "");
  } catch (err) {
    define = function(obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  exports.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunction.displayName = define(
    GeneratorFunctionPrototype,
    toStringTagSymbol,
    "GeneratorFunction"
  );

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      define(prototype, method, function(arg) {
        return this._invoke(method, arg);
      });
    });
  }

  exports.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  exports.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      define(genFun, toStringTagSymbol, "GeneratorFunction");
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  exports.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return PromiseImpl.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return PromiseImpl.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function(error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };
  exports.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    if (PromiseImpl === void 0) PromiseImpl = Promise;

    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList),
      PromiseImpl
    );

    return exports.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined$1) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined$1;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined$1;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  define(Gp, toStringTagSymbol, "Generator");

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  Gp[iteratorSymbol] = function() {
    return this;
  };

  Gp.toString = function() {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined$1;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  exports.values = values;

  function doneResult() {
    return { value: undefined$1, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined$1;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined$1;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined$1;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined$1;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined$1;
      }

      return ContinueSentinel;
    }
  };

  // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.
  return exports;

}(
  // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
   module.exports 
));

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  Function("r", "regeneratorRuntime = r")(runtime);
}
});

/**
 * Generates a string to be used as the `sizes` attribute in the `source` element.
 *
 */
// TODO RENAME 'BREAKPOINT TO SCREENWIDTH'

function generateSizes(breakpoints) {
  if (!breakpoints.length) return '';
  var sizes = breakpoints.map(function (_ref, index) {
    var breakpoint = _ref.breakpoint,
        imageWidth = _ref.imageWidth;
    var imageWidthPercent = Math.ceil(imageWidth / breakpoint * 100);

    if (index === breakpoints.length - 1) {
      return imageWidthPercent + "vw";
    }

    return "(max-width: " + breakpoint + "px) " + imageWidthPercent + "vw";
  });
  var result = sizes.join(', ');
  return result;
}
var filePathToBuffer = /*#__PURE__*/function () {
  var _ref2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(filePath) {
    var isRemoteFile;
    return runtime_1.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            isRemoteFile = filePath.startsWith('http') || filePath.startsWith('https');

            if (!isRemoteFile) {
              _context.next = 7;
              break;
            }

            _context.next = 4;
            return axios.get(filePath, {
              responseType: 'arraybuffer'
            });

          case 4:
            _context.t0 = _context.sent.data;
            _context.next = 8;
            break;

          case 7:
            _context.t0 = fs.readFileSync(filePath);

          case 8:
            return _context.abrupt("return", _context.t0);

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function filePathToBuffer(_x) {
    return _ref2.apply(this, arguments);
  };
}();
/**
 * Calculates a hash for the given image and query string
 *
 * */

var getHash = function getHash(buffer) {
  var hash = crypto.createHash('md4');
  hash.update(buffer);
  return hash.digest('hex');
};
var getBasename = function getBasename(url) {
  var result = path.basename(url, path.extname(url));
  return result;
};
/**
 * get the extensios of a url without the dot (.). Eg https://some.com/image.png returns `png`
 */

var getExtension = function getExtension(url) {
  var result = path.extname(url).slice(1).split('?')[0];
  return result;
};
var getMimeType = function getMimeType(extension) {
  switch (extension) {
    case 'jpeg':
    case 'jpg':
      return exports.MimeType.Jpeg;

    case 'png':
      return exports.MimeType.Png;

    case 'webp':
      return exports.MimeType.Webp;

    default:
      throw new Error("extension \"" + extension + "\" didn't resolve to any mime type");
  }
};
var generateAllImageInfo = function generateAllImageInfo(_ref3) {
  var imageWidths = _ref3.imageWidths,
      format = _ref3.format,
      imageName = _ref3.imageName,
      imagePublicDir = _ref3.imagePublicDir,
      imageFileDir = _ref3.imageFileDir;
  return imageWidths.map(function (imageWidth) {
    return {
      format: format,
      imagePath: imageFileDir + "/" + imageName + "-" + imageWidth + "." + format,
      imageWidth: imageWidth,
      src: imagePublicDir + "/" + imageName + "-" + imageWidth + "." + format,
      srcSetSrc: imagePublicDir + "/" + imageName + "-" + imageWidth + "." + format + " " + imageWidth + "w"
    };
  });
};
var generateSrcSet = function generateSrcSet(sources) {
  var result = sources.join(', ');
  return result;
};
function generateImageWidths(imageWidths, multipliers) {
  if (multipliers === void 0) {
    multipliers = [];
  }

  var generatedImageWidths = imageWidths.reduce(function (acc, imageWidth) {
    acc.add(imageWidth);
    multipliers.forEach(function (multiplier) {
      acc.add(imageWidth * multiplier);
    });
    return acc;
  }, new Set());
  var result = Array.from(generatedImageWidths);
  result.sort(function (a, b) {
    return a - b;
  });
  return result;
}

function generateLqip(_x) {
  return _generateLqip.apply(this, arguments);
}

function _generateLqip() {
  _generateLqip = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(_ref) {
    var inputImage, mimeType, _ref$options, _ref$options2, width, height, input;

    return runtime_1.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            inputImage = _ref.inputImage, mimeType = _ref.mimeType, _ref$options = _ref.options, _ref$options2 = _ref$options === void 0 ? {
              width: 20
            } : _ref$options, width = _ref$options2.width, height = _ref$options2.height;

            if (!(typeof inputImage === 'string')) {
              _context.next = 7;
              break;
            }

            _context.next = 4;
            return filePathToBuffer(inputImage);

          case 4:
            _context.t0 = _context.sent;
            _context.next = 8;
            break;

          case 7:
            _context.t0 = inputImage;

          case 8:
            input = _context.t0;
            return _context.abrupt("return", new Promise(function (resolve) {
              sharp(input).resize({
                width: width,
                height: height
              }).toBuffer().then(function (result) {
                var resultString = result.toString('base64');
                resolve("data:" + mimeType + ";base64," + resultString);
              });
            }));

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _generateLqip.apply(this, arguments);
}

function getAspectRatio(_x2) {
  return _getAspectRatio.apply(this, arguments);
}

function _getAspectRatio() {
  _getAspectRatio = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee2(_ref2) {
    var inputImage, input, _yield$sharp$metadata, width, height, aspectRatio;

    return runtime_1.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            inputImage = _ref2.inputImage;

            if (!(typeof inputImage === 'string')) {
              _context2.next = 7;
              break;
            }

            _context2.next = 4;
            return filePathToBuffer(inputImage);

          case 4:
            _context2.t0 = _context2.sent;
            _context2.next = 8;
            break;

          case 7:
            _context2.t0 = inputImage;

          case 8:
            input = _context2.t0;
            _context2.next = 11;
            return sharp(input).metadata();

          case 11:
            _yield$sharp$metadata = _context2.sent;
            width = _yield$sharp$metadata.width;
            height = _yield$sharp$metadata.height;

            if (!(width === undefined || height === undefined)) {
              _context2.next = 16;
              break;
            }

            throw new Error("Couldn't read width or height from the input");

          case 16:
            aspectRatio = height / width;
            return _context2.abrupt("return", aspectRatio);

          case 18:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _getAspectRatio.apply(this, arguments);
}

function processImage(_x) {
  return _processImage.apply(this, arguments);
}

function _processImage() {
  _processImage = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee3(_ref) {
    var imageUrl, breakpoints, _ref$multipliers, multipliers, withWebp, withLqip, lqipOptions, webpOptions, orgOptions, dir, publicDir, startTime, imageBuffer, hash, imageFileDir, imagePublicDir, imageName, imageExtension, mimeType, allImageInfo, allImageInfoWebP, orgSrc, webpSrc, lqip, sizes, srcSet, srcSetWebp, aspectRatio, isAllImagesCached, endTime, _endTime;

    return runtime_1.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            imageUrl = _ref.imageUrl, breakpoints = _ref.breakpoints, _ref$multipliers = _ref.multipliers, multipliers = _ref$multipliers === void 0 ? [2] : _ref$multipliers, withWebp = _ref.withWebp, withLqip = _ref.withLqip, lqipOptions = _ref.lqipOptions, webpOptions = _ref.webpOptions, orgOptions = _ref.orgOptions, dir = _ref.dir, publicDir = _ref.publicDir;
            // if (typeof window === 'undefined')
            //   throw new Error('node-image-processing must be run in the server.');
            startTime = new Date();
            _context3.next = 4;
            return filePathToBuffer(imageUrl);

          case 4:
            imageBuffer = _context3.sent;
            // get hash of the input image that will be used as cache key and as folder name
            hash = getHash(imageBuffer); // TODO: check if the image already exists. in cache
            // TODO: check in the cache if the same parameters were used

            imageFileDir = dir + "/" + hash;
            imagePublicDir = publicDir + "/" + hash;
            imageName = getBasename(imageUrl);
            imageExtension = getExtension(imageUrl);
            mimeType = getMimeType(imageExtension);
            allImageInfo = generateAllImageInfo({
              imageWidths: generateImageWidths(breakpoints.map(function (breakpoint) {
                return breakpoint.imageWidth;
              }), multipliers),
              format: imageExtension,
              formatOptions: orgOptions,
              imageName: imageName,
              imageFileDir: imageFileDir,
              imagePublicDir: imagePublicDir
            });
            allImageInfoWebP = !withWebp ? [] : generateAllImageInfo({
              imageWidths: breakpoints.map(function (breakpoint) {
                return breakpoint.imageWidth;
              }),
              format: 'webp',
              formatOptions: webpOptions,
              imageName: imageName,
              imageFileDir: imageFileDir,
              imagePublicDir: imagePublicDir
            }); // Make the default src the same as the largest image generated

            orgSrc = allImageInfo[allImageInfo.length - 1].src;
            webpSrc = allImageInfoWebP.length ? allImageInfoWebP[allImageInfoWebP.length - 1].src : undefined;

            if (!withLqip) {
              _context3.next = 21;
              break;
            }

            _context3.next = 18;
            return generateLqip({
              inputImage: imageBuffer,
              options: lqipOptions,
              mimeType: mimeType
            });

          case 18:
            _context3.t0 = _context3.sent;
            _context3.next = 22;
            break;

          case 21:
            _context3.t0 = undefined;

          case 22:
            lqip = _context3.t0;
            sizes = generateSizes(breakpoints);
            srcSet = generateSrcSet(allImageInfo.map(function (imageInfo) {
              return imageInfo.srcSetSrc;
            }));
            srcSetWebp = withWebp ? generateSrcSet(allImageInfoWebP.map(function (imageInfo) {
              return imageInfo.srcSetSrc;
            })) : undefined;
            _context3.next = 28;
            return getAspectRatio({
              inputImage: imageBuffer
            });

          case 28:
            aspectRatio = _context3.sent;
            // check if all of the paths exist
            isAllImagesCached = allImageInfo.every(function (imageInfo) {
              return fs.existsSync(imageInfo.imagePath);
            });
            isAllImagesCached = !withWebp || !isAllImagesCached ? isAllImagesCached : allImageInfoWebP.every(function (imageInfo) {
              return fs.existsSync(imageInfo.imagePath);
            });

            if (!isAllImagesCached) {
              _context3.next = 36;
              break;
            }

            endTime = new Date();
            console.log("Skipping image: " + imageName + " since it is already generated. Total elapsed time " + (endTime.getTime() - startTime.getTime()) + "ms of " + imageUrl);
            _context3.next = 43;
            break;

          case 36:
            // create directory
            if (!fs.existsSync(imageFileDir)) {
              fs.mkdirSync(imageFileDir, {
                recursive: true
              });
            } // Generate images in original file extension


            _context3.next = 39;
            return Promise.all(allImageInfo.map( /*#__PURE__*/function () {
              var _ref3 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(_ref2) {
                var imagePath, format, imageWidth, formatOptions;
                return runtime_1.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        imagePath = _ref2.imagePath, format = _ref2.format, imageWidth = _ref2.imageWidth, formatOptions = _ref2.formatOptions;
                        _context.next = 3;
                        return sharp(imageBuffer).toFormat(format, formatOptions).resize({
                          width: imageWidth
                        }).toFile(imagePath);

                      case 3:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x2) {
                return _ref3.apply(this, arguments);
              };
            }()));

          case 39:
            _context3.next = 41;
            return Promise.all(allImageInfoWebP.map( /*#__PURE__*/function () {
              var _ref5 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee2(_ref4) {
                var imagePath, format, imageWidth, formatOptions;
                return runtime_1.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        imagePath = _ref4.imagePath, format = _ref4.format, imageWidth = _ref4.imageWidth, formatOptions = _ref4.formatOptions;
                        _context2.next = 3;
                        return sharp(imageBuffer).toFormat(format, formatOptions).resize({
                          width: imageWidth
                        }).toFile(imagePath);

                      case 3:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));

              return function (_x3) {
                return _ref5.apply(this, arguments);
              };
            }()));

          case 41:
            _endTime = new Date();
            console.log("Generated " + (allImageInfo.length + allImageInfoWebP.length) + " versions, in " + (_endTime.getTime() - startTime.getTime()) + "ms of " + imageUrl);

          case 43:
            return _context3.abrupt("return", {
              src: orgSrc,
              srcSet: srcSet,
              srcWebp: webpSrc,
              srcSetWebp: srcSetWebp,
              lqip: lqip,
              aspectRatio: aspectRatio,
              sizes: sizes
            });

          case 44:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _processImage.apply(this, arguments);
}

exports.filePathToBuffer = filePathToBuffer;
exports.generateAllImageInfo = generateAllImageInfo;
exports.generateImageWidths = generateImageWidths;
exports.generateLqip = generateLqip;
exports.generateSizes = generateSizes;
exports.generateSrcSet = generateSrcSet;
exports.getAspectRatio = getAspectRatio;
exports.getBasename = getBasename;
exports.getExtension = getExtension;
exports.getHash = getHash;
exports.getMimeType = getMimeType;
exports.processImage = processImage;
//# sourceMappingURL=node-image-processing.cjs.development.js.map
