import { MimeType, InputImage } from './types';
export declare type LqipOptions = {
    /**
     * default width is 20
     */
    width?: number;
    /**
     * if no height is provided, the height is auto
     */
    height?: number;
};
export interface IGenerateLqip {
    inputImage: InputImage;
    mimeType: MimeType;
    options?: LqipOptions;
}
export declare function generateLqip({ inputImage, mimeType, options: { width, height }, }: IGenerateLqip): Promise<string>;
export interface IGetAspectRatio {
    inputImage: InputImage;
}
export declare function getAspectRatio({ inputImage }: IGetAspectRatio): Promise<number>;
