/// <reference types="node" />
import { WebpOptions, JpegOptions, PngOptions, FormatEnum, AvailableFormatInfo } from 'sharp';
export declare type Breakpoint = {
    imageWidth: number;
    breakpoint: number;
};
export declare enum MimeType {
    Jpeg = "image/jpeg",
    Png = "image/png",
    Webp = "image/webp"
}
export declare type Format = keyof FormatEnum | AvailableFormatInfo;
export declare type ImageInfo = {
    /**
     * The src of the image in the public directory (without width descriptor)
     */
    src: string;
    /**
     * The src used to generate srcSet (width the width descriptor in the end)
     */
    srcSetSrc: string;
    /**
     * The path where to save the image
     */
    imagePath: string;
    format: Format;
    imageWidth: number;
    formatOptions?: WebpOptions | JpegOptions | PngOptions;
};
/**
 * Either a local file path, or a Buffer
 */
export declare type InputImage = Buffer | string;
