/// <reference types="node" />
import { ImageInfo, Breakpoint, MimeType, Format } from './types';
import { WebpOptions, JpegOptions, PngOptions } from 'sharp';
/**
 * Generates a string to be used as the `sizes` attribute in the `source` element.
 *
 */
export declare function generateSizes(breakpoints: Breakpoint[]): string;
export declare const filePathToBuffer: (filePath: string) => Promise<Buffer>;
/**
 * Calculates a hash for the given image and query string
 *
 * */
export declare const getHash: (buffer: Buffer) => string;
export declare const getBasename: (url: string) => string;
/**
 * get the extensios of a url without the dot (.). Eg https://some.com/image.png returns `png`
 */
export declare const getExtension: (url: string) => Format;
export declare const getMimeType: (extension: Format | 'jpg') => MimeType;
interface IGenerateAllImageInfo {
    imageWidths: number[];
    format: Format;
    formatOptions?: WebpOptions | JpegOptions | PngOptions;
    imageName: string;
    imagePublicDir: string;
    imageFileDir: string;
}
export declare const generateAllImageInfo: ({ imageWidths, format, imageName, formatOptions, imagePublicDir, imageFileDir, }: IGenerateAllImageInfo) => ImageInfo[];
export declare const generateSrcSet: (sources: string[]) => string;
export declare function generateImageWidths(imageWidths: number[], multipliers?: number[]): number[];
export {};
